import Vue from 'vue'
import $P from '../../../../../src/utils/common.js'
Vue.component("dcsp",{
    template:
    '<div :id="id">' +
    '<div v-for="group in groups"class="form-group">' +
    '<div  v-for="row in group.COLS" :class="row.COL_SIZE">' +
    '<template v-if="per_ui">'+
    '<label :class="row.LAB_SIZE" :style="row.LAB_STYLE"> {{row.COL_CAPTION}}: </label>'+
    '<div  :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-if="row.WIDGET_TYPE == \'select\'">' +
    '<dcselect :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></dcselect>'+
    '</div>'+
    '<div  :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-else-if="row.WIDGET_TYPE == \'select3\'">' +
    '<dcselect3 :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></dcselect>'+
    '</div>'+
    '<div :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-else-if="row.WIDGET_TYPE == \'date\'">' +
    '<dcdate :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></dcdate>'+
    '</div>'+
    '<div :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-else-if="row.WIDGET_TYPE == \'textarea\'">' +
    '<dctextarea :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></dcdate>'+
    '</div>'+
    '<div :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-else-if="row.WIDGET_TYPE == \'text\'">' +
    '   <dcinput :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></dcinput>'+
    '</div>'+
    '<div :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-else-if="row.WIDGET_TYPE == \'text2\'">' +
    '   <dcinput2 :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></dcinput2>'+
    '</div>'+
    '<div :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-else="row.WIDGET_TYPE == \'select4\'">' +
    '   <select4 :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></select4>'+
    '</div>'+
    '</template>'+
    '<template v-else>'+
    '<div class="input-group" style="width: 99%">'+
    '<label class="input-group-addon control-label" :style="row.LAB_STYLE"> {{row.COL_CAPTION}}: </label>'+
    '<dcselect :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"  v-if="row.WIDGET_TYPE == \'select\'"/></dcselect>'+
    '<autotext :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"  v-else-if="row.WIDGET_TYPE == \'autotext\'"/></autotext>'+
    '<dcselect3 :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"  v-else-if="row.WIDGET_TYPE == \'select3\'"/></dcselect>'+
    '<dcdate :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM" v-else-if="row.WIDGET_TYPE == \'date\'"/></dcdate>'+
    '<dctextarea :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM" v-else-if="row.WIDGET_TYPE == \'textarea\'"/></dcdate>'+
    '<dcinput :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"  v-else-if="row.WIDGET_TYPE == \'text\'"/></dcinput>' +
    '<dcinput2 :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"  v-else-if="row.WIDGET_TYPE == \'text2\'"/></dcinput2>' +
    '<select4 :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"  v-else/></select4>' +
'</div>'+
    '</template>'+
    '</div>' +
    '</div>' +
    '<input v-for="row in hiddenEls" type="hidden" :name="row.COL_CODE" v-model="vobj[row.COL_CODE]" :id="row.COL_CODE"  />'+
    '</div>',

    data:function(){
        var rsData = this.configData != undefined ? this.configData : $P.getPageConditionCofnig(this.page_id,this.grid_id,true);
        var _id = "div"+$P.randomForJs().toString().substring(2,7);
        var bREEvent = !$P.isnullorempty(this.enter_btn);
        var me = this;

        var enterEvent = function(){
            $("#"+me.enter_btn).click();
        };
        return {
            id:_id,
            me:this,
            groups:rsData["GROUPS"],
            hiddenEls:rsData["HIDDEN_COLS"],
            subFuns:[],
            bREEvent:bREEvent,
            enterEvent:enterEvent
        };
    },
    props:{
        "vobj":{type: Object,required: true},
        "page_id":{type: String,required: true},
        "grid_id":{type: String,required: true},
        "per_ui":{type: Boolean},
        "configData":{type: Object},
        "enter_btn":{type: String},
    },
    methods:{

    },
    mounted:function(){
        for( var i=0;i<this.subFuns.length;i++){
            this.subFuns[i].call();
        }
    }
});

Vue.component("dcdp",{
    template:
    '<div :id="id">' +
    '<div v-for="group in groups"class="form-group">' +
    '<div  v-for="row in group.COLS" :class="row.COL_SIZE">' +
    '<template v-if="per_ui">'+
    '<label :class="row.LAB_SIZE" :style="row.LAB_STYLE"> {{row.COL_CAPTION}}: </label>'+
    '<div  :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-if="row.WIDGET_TYPE == \'select\'">' +
    '<dcselect :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></dcselect>'+
    '</div>'+
    '<div  :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-else-if="row.WIDGET_TYPE == \'select3\'">' +
    '<dcselect3 :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></dcselect>'+
    '</div>'+
    '<div :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-else-if="row.WIDGET_TYPE == \'date\'">' +
    '<dcdate :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></dcdate>'+
    '</div>'+
    '<div :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-else-if="row.WIDGET_TYPE == \'textarea\'">' +
    '<dctextarea :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></dcdate>'+
    '</div>'+
    '<div :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-else-if="row.WIDGET_TYPE == \'text\'">' +
    '   <dcinput :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></dcinput>'+
    '</div>'+
    '<div :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-else-if="row.WIDGET_TYPE == \'text2\'">' +
    '   <dcinput2 :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></dcinput2>'+
    '</div>'+
    '<div :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-else-if="row.WIDGET_TYPE == \'custom\'">' +
    '   <dccustom :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></dccustom>'+
    '</div>'+
    '<div :class="row.CONTENT_SIZE" :style="row.CONTENT_STYLE" v-else="row.WIDGET_TYPE == \'select4\'">' +
    '   <select4 :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"/></select4>'+
    '</div>'+
    '</template>'+
    '<template v-else>'+
    '<div class="input-group" style="width: 99%">'+
    '<label class="input-group-addon control-label" :style="row.LAB_STYLE"> {{row.COL_CAPTION}}: </label>'+
    '<dcselect :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"  v-if="row.WIDGET_TYPE == \'select\'"/></dcselect>'+
    '<dcselect3 :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"  v-else-if="row.WIDGET_TYPE == \'select3\'"/></dcselect>'+
    '<dcdate :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM" v-else-if="row.WIDGET_TYPE == \'date\'"/></dcdate>'+
    '<dctextarea :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM" v-else-if="row.WIDGET_TYPE == \'textarea\'"/></dcdate>'+
    '<dcinput :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"  v-else-if="row.WIDGET_TYPE == \'text\'"/></dcinput>' +
    '<dcinput2 :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"  v-else-if="row.WIDGET_TYPE == \'text2\'"/></dcinput2>' +
    '<dccustom :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"  v-else-if="row.WIDGET_TYPE == \'custom\'"/></dccustom>' +
    '<select4 :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" :rule="row.VERIFY_RULE" :param="row.WIDGET_PARAM"  v-else/></select4>' +
    '</div>'+
    '</template>'+
    '</div>' +
    '</div>' +
    '<dchidden v-for="row in hiddenEls" :row="row" :root="me" :vobj="vobj" :name="row.COL_CODE" v-model="vobj[row.COL_CODE]" :id="row.COL_CODE"  />'+
    '</div>',

    data:function(){
        var rsData = this.config_data != undefined ? this.config_data : $P.getPageFormCofnig(this.page_id,this.form_id,true);
        var _id = "div"+$P.randomForJs().toString().substring(2,7)
        return {
            id:_id,
            me:this,
            groups:rsData["GROUPS"],
            hiddenEls:rsData["HIDDEN_COLS"],
            subFuns:[]
        };
    },
    props:{
        "vobj":{type: Object,required: true},
        "page_id":{type: String,required: true},
        "form_id":{type: String,required: true},
        "per_ui":{type: Boolean},
        "config_data":{type: Object}
    },
    methods:{

    },
    mounted:function(){
        for( var i=0;i<this.subFuns.length;i++){
            this.subFuns[i].call();
        }
    }
});


Vue.component('dccustom', {
    template: $P.getCustomTemplate(this),
    data: $P.getCustomData,
    props: ['name','id','vobj','rule','bind_name','paramobj','param','row','root','use_id'], //接收一个 value prop
    methods: $P.getCustomMethods(),
    mounted: $P.getCustomMounted
});

Vue.component('dcinput', {
    template: '<input type="text" :name="name" :style="r_style" :placeholder="r_placeholder"  v-bind:readonly="r_readonly" ' +
    'v-model="vobj[bind_name == null ? name : bind_name]" :id="r_id" class="form-control"' +
    ' :value="r_value" @input="handleInput" />',
    data: function () {
        var paramConfig = eval('(' + '{'+$P.gv(this.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }
        return {
            r_readonly:paramConfig["readonly"] == true,
            r_style:$P.gv(paramConfig["style"]),
            r_value: this.vobj[this.name],
            r_placeholder: paramConfig["placeholder"],
            r_id:$P.isnullorempty(this.id) ? this.name :this.id
        };
    },
    props: ['name','id','vobj','rule','bind_name','paramobj','param','row','root','use_id'], //接收一个 value prop
    methods: {
        handleInput:function(event) {
            var value = event.target.value.forbiddenWord();
            this.vobj[this.name]=value;
            this.$emit('input', value); //触发 input 事件，并传入新值
        }
    },
    mounted:function(){
        if(this.row && !$P.isnullorempty(this.row["DEFALUT_VALUE"])){
            var defaultValue = this.row["DEFALUT_VALUE"];
            if(defaultValue.indexOf("fun=") >=0){
                defaultValue = defaultValue.replace("fun=","");
                defaultValue = eval(defaultValue);
                Vue.set(this.vobj,this.name,defaultValue);
            }else{
                Vue.set(this.vobj,this.name,this.row["DEFALUT_VALUE"]);
            }
        }
        var ruleConfig = eval('(' + '{'+$P.gv(this.rule)+'}' + ')');
        $P.doElRule(ruleConfig,$(this.$el));

        var me=this;
        var paramConfig = eval('(' + '{'+$P.gv(me.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }

        if(me.root != undefined && me.root.bREEvent == true){
            try{
            $(me.$el).keyup(function(event){
                if(event.keyCode ==13 && !$P.isnullorempty($(this).val())){
                    me.root.enterEvent.call(this);
                }
            });
            }catch (e){
                console.log("回车事件异常",e);
            }
        }

    }
});


Vue.component('dchidden', {
    template: '<input type="hidden" :name="name" :style="r_style"  v-bind:readonly="r_readonly" ' +
    'v-model="vobj[bind_name == null ? name : bind_name]" :id="r_id" class="form-control"' +
    ' :value="r_value" @input="handleInput" />',
    data: function () {
        var paramConfig = eval('(' + '{'+$P.gv(this.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }
        return {
            r_type:$P.gv(this.type,'text'),
            r_readonly:paramConfig["readonly"] == true,
            r_style:$P.gv(paramConfig["style"]),
            r_value: this.vobj[this.name],
            r_id:$P.isnullorempty(this.id) ? this.name :this.id
        };
    },
    props: ['name','id','vobj','rule','bind_name','paramobj','param','row','root','use_id'], //接收一个 value prop
    methods: {
        handleInput:function(event) {
            var value = event.target.value.forbiddenWord();
            this.vobj[this.name]=value;
            this.$emit('input', value); //触发 input 事件，并传入新值
        }
    },
    mounted:function(){
        if(this.row && !$P.isnullorempty(this.row["DEFALUT_VALUE"])){
            var defaultValue = this.row["DEFALUT_VALUE"];
            if(defaultValue.indexOf("fun=") >=0){
                defaultValue = defaultValue.replace("fun=","");
                defaultValue = eval(defaultValue);
                Vue.set(this.vobj,this.name,defaultValue);
            }else{
                Vue.set(this.vobj,this.name,this.row["DEFALUT_VALUE"]);
            }
        }
        var ruleConfig = eval('(' + '{'+$P.gv(this.rule)+'}' + ')');
        $P.doElRule(ruleConfig,$(this.$el));

        var me=this;
        var paramConfig = eval('(' + '{'+$P.gv(me.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }

    }
});

Vue.component('dcinput2', {
    template:    '<div class="input-group">' +
    '<input type="text" :name="name" :style="r_style"  v-bind:readonly="r_readonly" ' +
    'v-model="vobj[bind_name == null ? name : bind_name]" :id="r_id" class="form-control"' +
    ' :value="r_value" @input="handleInput" />'+
    '<span class="input-group-btn" style="display: none;" :id="r_button_update_div_id"> ' +
    '<button type="button" class="btn btn-primary"  :id="r_button_extend_id" :name="name" >{{r_text}}</button> ' +
    '</span>' +
    '</div>',
    data: function () {
        var paramConfig = eval('(' + '{'+$P.gv(this.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }
        var extendConfig= $.extend({},paramConfig.extendButton);

        return {
            r_readonly:paramConfig["readonly"] == true,
            r_style:$P.gv(paramConfig["style"]),
            r_value: this.vobj[this.name],
            r_id:$P.isnullorempty(this.id) ? this.name :this.id,
            r_button_extend_id:$P.isnullorempty(this.id) ? this.name+"_btn_extend" :this.id+"_btn_extend",
            r_button_update_div_id:$P.isnullorempty(this.id) ? this.name+"_btn_extend_div_id" :this.id+"_btn_extend_div_id",
            r_text:$P.gv(extendConfig.updateText,"更新")
        };
    },
    props: ['name','id','vobj','rule','bind_name','paramobj','param','row','root','use_id'], //接收一个 value prop
    methods: {
        handleInput:function(event) {
            var value = event.target.value.forbiddenWord();
            this.vobj[this.name]=value;
            this.$emit('input', value); //触发 input 事件，并传入新值
        }
    },
    mounted:function(){
        if(this.row && !$P.isnullorempty(this.row["DEFALUT_VALUE"])){
            var defaultValue = this.row["DEFALUT_VALUE"];
            if(defaultValue.indexOf("fun=") >=0){
                defaultValue = defaultValue.replace("fun=","");
                defaultValue = eval(defaultValue);
                Vue.set(this.vobj,this.name,defaultValue);
            }else{
                Vue.set(this.vobj,this.name,this.row["DEFALUT_VALUE"]);
            }
        }
        var ruleConfig = eval('(' + '{'+$P.gv(this.rule)+'}' + ')');
        $P.doElRule(ruleConfig,$(this.$el));

        var me=this;
        var paramConfig = eval('(' + '{'+$P.gv(me.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }

        //扩展按钮处理 begin
        var extendConfig=paramConfig.extendButton;
        if(!$P.isnullorempty(extendConfig)){
            if(extendConfig.showUpdate===true){
                $('#'+this.r_button_update_div_id).show();
            }
            /*if(!$P.isnullorempty(extendConfig.updateText)){
                console.log(this.r_button_update_div_id);
                $('#'+this.r_button_update_div_id).val(extendConfig.updateText);
            }*/

            if(extendConfig.callfun != undefined && (typeof extendConfig.callfun) == 'function'){
                $('#'+this.r_button_extend_id).click(function () {
                    extendConfig.callfun.call(this,$('#'+this.name).val(),this.name);
                });
            }
        }
        //end

    }
});

Vue.component('select4', {
    template:
    '<div class="input-group" style="width: 100%">' +
    '<select class="form-control" xtype="select3" :style="r_style"   isdropdown="true" :name="name" :id="r_id" :data-id="r_value" > </select>'+
    '<span class="input-group-btn" style="display: none;" :id="r_button_edit_div_id"> ' +
    '<button type="button" class="btn btn-primary"  v-on:click="showinfo(r_button_id)" :id="r_button_id" >{{r_editText}}</button> ' +
    '</span>' +
    '<span class="input-group-btn" style="display: none;" :id="r_button_update_div_id"> ' +
    '<button type="button" class="btn btn-primary"  :id="r_button_extend_id" :name="name" >{{r_updateText}}</button> ' +
    '</span>' +
    '</div>',
    data: function () {
        var paramConfig = {};
        try{
            paramConfig = eval('(' + '{'+$P.gv(this.param)+'}' + ')');
        }catch (e){
            console.log(this,e);
        };

        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }

        var extendConfig=paramConfig.extendButton;
        if(extendConfig == undefined){
            extendConfig = {};
        }

        return {
            r_editText:$P.gv(extendConfig.editText,"编辑"),
            r_updateText:$P.gv(extendConfig.updateText,"更新"),
            r_readonly:paramConfig["readonly"] == true,
            r_style:$P.gv(paramConfig["style"]),
            r_value: this.vobj[this.name],
            r_id:$P.isnullorempty(this.id) ? this.name :this.id,
            r_button_id:$P.isnullorempty(this.id) ? this.name+"_btn" :this.id+"_btn",
            r_button_extend_id:$P.isnullorempty(this.id) ? this.name+"_btn_extend" :this.id+"_btn_extend",
            r_button_update_div_id:$P.isnullorempty(this.id) ? this.name+"_btn_extend_div_id" :this.id+"_btn_extend_div_id",
            r_button_edit_div_id:$P.isnullorempty(this.id) ? this.name+"button_edit_div_id" :this.id+"_button_edit_div_id"
        };
    },
    props: ['name','id','vobj','rule','param','paramobj','root','bind_name','row','use_id'], //接收一个 value prop 传入进来的参数
    methods: {
        handleInput:function(event) {
            var value = event.target.value.forbiddenWord();
            this.vobj[this.name]=value;
        },
        showinfo:function (selectBtnId) {
            if(typeof  showinfo2==="function"){
                try{
                    showinfo2.call(selectBtnId);
                }catch(e){

                }
            }
        }
    },
    mounted:function(){
        if(this.row && !$P.isnullorempty(this.row["DEFALUT_VALUE"])){
            var defaultValue = this.row["DEFALUT_VALUE"];
            if(defaultValue.indexOf("fun=") >=0){
                defaultValue = defaultValue.replace("fun=","");
                defaultValue = eval(defaultValue);
                Vue.set(this.vobj,this.name,defaultValue);
            }else{
                Vue.set(this.vobj,this.name,this.row["DEFALUT_VALUE"]);
            }
        }


        var me = this;
        var meEl;

        if(this.use_id != true && this.root && this.root.$el){
            //meEl = $(this.root.$el).find("#"+me.name);
            meEl = $("#"+this.root.id+" #"+me.name)
        }else {
            meEl = $("#"+me.name);
        }

        var ruleConfig = eval('(' + '{'+$P.gv(me.rule)+'}' + ')');
        $P.doElRule(ruleConfig,meEl);

        var paramConfig = eval('(' + '{'+$P.gv(me.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }



        if(!$P.isnullorempty(paramConfig.dic_code)){
            $P.select3FromDic(meEl,paramConfig.dic_code,{
                idField: 'PARACODE',
                keyField: 'ORI_PARANAME',
                effectiveFields: ['ORI_PARANAME'],
                defaultValue: me.vobj[me.name],
                remoteFilter:paramConfig.remoteFilter==true,
                readonly:paramConfig.readonly == true,
                multiple:paramConfig.multiple == true,
            },function(e){
                if(paramConfig.callfun != undefined && (typeof paramConfig.callfun) == 'function'){
                    paramConfig.callfun.call(this,e);
                }else{
                    if(paramConfig.multiple){
                        var ay = me.vobj[$P.gv(me.bind_name,me.name)];
                        if(ay == undefined){
                            ay = [];
                        }
                        ay.push(e.params.data.id);
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), ay);
                    }else {
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), e.params.data.id);
                    }

                    // Vue.set(me.vobj, $P.gv(me.bind_name,me.name), data["id"])
                    //meEl.attr("data-id", data["id"]);
                }
            },function (e) {
                if(paramConfig.multiple){
                    var ay = me.vobj[$P.gv(me.bind_name,me.name)];
                    if(ay == undefined){
                        ay = [];
                    }
                    ay.splice(ay.valueIndexOf(e.params.data.id),1)
                    Vue.set(me.vobj, $P.gv(me.bind_name,me.name), ay);
                }else {
                    Vue.set(me.vobj, $P.gv(me.bind_name,me.name), "");
                }
            }
            );
        }else if(paramConfig.hasOwnProperty("config")){
            if(paramConfig.readonly == true){
                paramConfig.config.readonly = true;
            }

            if(paramConfig.multiple == true){
                paramConfig.config.multiple = true;
            }


            var callFun = paramConfig.callfun;
            if(callFun == null || callFun ==undefined){
                callFun = function(e){
                    if(paramConfig.config.multiple){
                        var ay = me.vobj[$P.gv(me.bind_name,me.name)];

                        if(ay == undefined ||  (typeof ay) == 'string' ){
                            ay = [];
                        }
                        ay.push(e.params.data.id);
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), ay);
                    }else {
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), e.params.data.id);
                    }
                }
            }

            var unselectCallFun = paramConfig.unselectCallFun;
            if(unselectCallFun == null || unselectCallFun ==undefined){
                unselectCallFun = function(e){
                    if(paramConfig.config.multiple){
                        var ay = me.vobj[$P.gv(me.bind_name,me.name)];
                        if(ay == undefined){
                            ay = [];
                        }
                        ay.splice(ay.valueIndexOf(e.params.data.id),1)
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), ay);
                    }else {
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), "");
                    }
                }
            }

            if(!$P.isnullorempty(me.vobj[me.name])){
                paramConfig.config.defaultValue=me.vobj[me.name];
            }



            var postData = {};

            if(paramConfig.param != undefined && (typeof paramConfig.param ) == 'function'){
                $.extend(postData,paramConfig.param.call(me,me.vobj,me.name));
            }else if(paramConfig.param != undefined ){
                $.extend(postData,paramConfig.param);
            }


            $P.select3(meEl,postData,paramConfig.config,callFun,paramConfig.url,unselectCallFun);
        }else {

        }

        //扩展按钮处理 begin
        var extendConfig=paramConfig.extendButton;
        if(!$P.isnullorempty(extendConfig)){
            if(extendConfig.showEdit===true){
                $('#'+this.r_button_edit_div_id).show();
            }
            if(!$P.isnullorempty(extendConfig.editText)){
                $('#'+this.r_button_edit_div_id).val(extendConfig.editText);
            }

            if(extendConfig.showUpdate===true){
                $('#'+this.r_button_update_div_id).show();
            }
            if(!$P.isnullorempty(extendConfig.updateText)){
                $('#'+this.r_button_update_div_id).val(extendConfig.updateText);
            }

            if(extendConfig.callfun != undefined && (typeof extendConfig.callfun) == 'function'){
                $('#'+this.r_button_extend_id).click(function () {
                    try{
                        extendConfig.callfun.call(this,$('#'+this.name).val(),this.name);
                    }catch (e){

                    }
                });
            }
        }
        //end
    }
});

Vue.component('dctextarea', {
    template: '<textarea :name="name" :style="r_style" v-bind:readonly="r_readonly" v-model="vobj[bind_name == null ? name : bind_name]" :id="r_id" class="form-control" :value="r_value" @input="handleInput"/>',
    data: function () {
        var paramConfig = eval('(' + '{'+$P.gv(this.param)+'}' + ')');

        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }
        return {
            r_readonly:paramConfig["readonly"] == true,
            r_style:$P.gv(paramConfig["style"]),
            r_value: this.vobj[this.name],
            r_id:$P.isnullorempty(this.id) ? this.name :this.id
        };
    },
    props: ['name','id','vobj','rule','bind_name','paramobj','param','row','root','use_id'], //接收一个 value prop
    methods: {
        handleInput:function(event) {
            var value = event.target.value.forbiddenWord();
            this.vobj[this.name]=value;
            this.$emit('input', value); //触发 input 事件，并传入新值
        }
    },
    mounted:function(){
        if(this.row && !$P.isnullorempty(this.row["DEFALUT_VALUE"])){
            var defaultValue = this.row["DEFALUT_VALUE"];
            if(defaultValue.indexOf("fun=") >=0){
                defaultValue = defaultValue.replace("fun=","");
                defaultValue = eval(defaultValue);
                Vue.set(this.vobj,this.name,defaultValue);
            }else{
                Vue.set(this.vobj,this.name,this.row["DEFALUT_VALUE"]);
            }
        }
        var ruleConfig = eval('(' + '{'+$P.gv(this.rule)+'}' + ')');
        $P.doElRule(ruleConfig,$(this.$el));

    }
});

Vue.component('dcmutiselect',{
    template:
    '<div class="input-group">' +
    '<select :data-placeholder="r_dataplace_holder" :id="r_id" class="chosen-select" multiple="multiple" :style="r_style" tabindex="4">'+
    ' </select>'+
    '</div>',
    data:function(){

        var paramConfig = eval('(' + '{'+$P.gv(this.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }
        return {
            r_readonly:paramConfig["readonly"] == true,
            r_style:$P.gv(paramConfig["style"]),
            r_value: this.vobj[this.name],
            r_dataplace_holder:$P.gv(paramConfig["dataplace_holder"]),
            r_id:$P.isnullorempty(this.id) ? this.name :this.id
        };
    },
    props: ['name','id','vobj','rule','param','paramobj','root','bind_name','row','use_id'], //接收一个 value prop
    mounted:function(){


        var me = this;

        if(this.row && !$P.isnullorempty(this.row["DEFALUT_VALUE"])){
            var defaultValue = this.row["DEFALUT_VALUE"];
            if(defaultValue.indexOf("fun=") >=0){
                defaultValue = defaultValue.replace("fun=","");
                defaultValue = eval(defaultValue);
                Vue.set(this.vobj,this.name,defaultValue);
            }else{
                Vue.set(this.vobj,this.name,this.row["DEFALUT_VALUE"]);
            }
        }

        var paramConfig = eval('(' + '{'+$P.gv(me.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }

        var meEl;
        if(this.use_id != true && this.root && this.root.$el){
            //meEl = $(this.root.$el).find("#"+me.name);
            meEl = $("#"+this.root.id+" #"+me.name)
        }else {
            meEl = $("#"+me.name);
        }
        if(!$P.isnullorempty(paramConfig.mutiselect)){
            meEl.chosen({
                allow_single_deselect :true,
                max_selected_options:10,
                no_results_text:'没有匹配项'
            });

            meEl.chosen().change(function(){
                meEl.html("");
                meEl.chosen("destroy");

                if($P.isnullorempty(paramConfig.dataplace_holder)){
                    $("<option value='-1'>-请选择-</option>").appendTo("#"+me.name);
                }
                else{
                    $("<option value='-1'>'+paramConfig.dataplace_holder+'</option>").appendTo("#"+me.name);
                }

                if(!$P.isnullorempty(paramConfig.mutiselectUrl)){
                    app.callAjaxPost(paramConfig.mutiselectUrl, param, function (result) {
                        if(result.success){
                            $.each(result.data,function(i){
                                $("<option value='"+data[i].code+"'>"+data[i].value+"</option>").appendTo("#"+me.name);
                            });

                            meEl.trigger("chosen:updated");
                            meEl.chosen({
                                allow_single_deselect :true,
                                max_selected_options:10,
                                no_results_text:'没有匹配项'
                            });
                            Vue.set(me.vobj, $P.gv(me.bind_name,me.name),meEl.val());
                        }
                        else{
                            Vue.set(me.vobj, $P.gv(me.bind_name,me.name), meEl.val());
                        }
                    });
                }


            });
        }else{
            var callFun = paramConfig.callfun;
            if(callFun == null || callFun ==undefined){
                callFun = function(data, e){
                    Vue.set(me.vobj, $P.gv(me.bind_name,me.name), meEl.val());
                }
            }
        }
    }

});


Vue.component('autotext', {
    template: '<input type="text" :name="name" :style="r_style"  v-bind:readonly="r_readonly" ' +
        'v-model="vobj[bind_name == null ? name : bind_name]" :id="r_id" class="form-control"' +
        ' :value="r_value" @input="handleInput" />',
    data: function () {
        var paramConfig = eval('(' + '{'+$P.gv(this.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }
        return {
            r_readonly:paramConfig["readonly"] == true,
            r_style:$P.gv(paramConfig["style"]),
            r_value: this.vobj[this.name],
            r_id:$P.isnullorempty(this.id) ? this.name :this.id
        };
    },
    props: ['name','id','vobj','rule','param','paramobj','root','bind_name','row','use_id'], //接收一个 value prop
    methods: {
        handleInput:function(event) {
            var value = event.target.value.forbiddenWord();
            this.vobj[this.name]=value;
        }
    },
    mounted:function(){
        if(this.row && !$P.isnullorempty(this.row["DEFALUT_VALUE"])){
            var defaultValue = this.row["DEFALUT_VALUE"];
            if(defaultValue.indexOf("fun=") >=0){
                defaultValue = defaultValue.replace("fun=","");
                defaultValue = eval(defaultValue);
                Vue.set(this.vobj,this.name,defaultValue);
            }else{
                Vue.set(this.vobj,this.name,this.row["DEFALUT_VALUE"]);
            }
        }

        var me = this;

        var meEl;
        if(this.use_id != true && this.root && this.root.$el){
            //meEl = $(this.root.$el).find("#"+me.name);
            meEl = $("#"+this.root.id+" #"+me.name)
        }else {
            meEl = $("#"+me.name);
        }

        var ruleConfig = eval('(' + '{'+$P.gv(me.rule)+'}' + ')');
        $P.doElRule(ruleConfig,meEl);

        var paramConfig = eval('(' + '{'+$P.gv(me.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }
        var key = paramConfig.config.idField;

        meEl.autocomplete({
                source: function (request, response) {
                    app.callAjaxPost(paramConfig.url, {key:request.term}, function (result) {
                        if (result.success == true) {
                            response(
                                $.map(result.data, function (item) {
                                    return { value: item.keyvalue, label: item.value };
                                }));
                        }
                        else {

                        }
                    });

                },
                focus: function (event, ui) {
                    // Vue.set(boxVue.boxRelated, me.name, ui.item.value);
                    meEl.val(ui.item.value);
                    // return false;
                },
                select: function (event, ui) {
                    Vue.set(me.vobj, $P.gv(me.bind_name,me.name), ui.item.value)
                    meEl.attr("data-id", ui.item.keyvalue);
                    // return true;
                }
            });



        // if(!$P.isnullorempty(paramConfig.config)) {
        //     $P.initDropdownFromDic(meEl, paramConfig.config, {
        //         idField: 'PARACODE',
        //         keyField: 'PARANAME',
        //         effectiveFields: ['PARANAME'],
        //         defaultValue: me.vobj[me.name],
        //         readonly: paramConfig.readonly == true,
        //         bEmpty: paramConfig.bEmpty == undefined ? false : paramConfig.bEmpty
        //     }, function (data, e) {
        //         if (paramConfig.callfun != undefined && (typeof paramConfig.callfun) == 'function') {
        //             paramConfig.callfun.call(this, data);
        //         } else {
        //             Vue.set(me.vobj, $P.gv(me.bind_name, me.name), data["id"])
        //             meEl.attr("data-id", data["id"]);
        //         }
        //     });
        // }
    }
});

Vue.component('dcselect', {
    template:
    '<div class="input-group">' +
    '<input type="text" class="form-control" isdropdown="true" :style="r_style" :name="name" :id="r_id" :data-id="r_value" @input="handleInput" />' +
    '<div class="input-group-btn">' +
    '<button type="button" class="btn btn-white dropdown-toggle" data-toggle="dropdown">' +
    '<span class="caret"></span>' +
    '</button>' +
    '<ul class="dropdown-menu dropdown-menu-right" role="menu"></ul>' +
    '</div>' +
    '</div>',
    data: function () {
        var paramConfig = eval('(' + '{'+$P.gv(this.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }

        return {
            r_readonly:paramConfig["readonly"] == true,
            r_style:$P.gv(paramConfig["style"]),
            r_value: this.vobj[this.name],
            r_id:$P.isnullorempty(this.id) ? this.name :this.id
        };
    },
    props: ['name','id','vobj','rule','param','paramobj','root','bind_name','row','use_id'], //接收一个 value prop
    methods: {
        handleInput:function(event) {
            var value = event.target.value.forbiddenWord();
            this.vobj[this.name]=value;
        }
    },
    mounted:function(){
        if(this.row && !$P.isnullorempty(this.row["DEFALUT_VALUE"])){
            var defaultValue = this.row["DEFALUT_VALUE"];
            if(defaultValue.indexOf("fun=") >=0){
                defaultValue = defaultValue.replace("fun=","");
                defaultValue = eval(defaultValue);
                Vue.set(this.vobj,this.name,defaultValue);
            }else{
                Vue.set(this.vobj,this.name,this.row["DEFALUT_VALUE"]);
            }
        }

        var me = this;

        var meEl;
        if(this.use_id != true && this.root && this.root.$el){
            //meEl = $(this.root.$el).find("#"+me.name);
            meEl = $("#"+this.root.id+" #"+me.name)
        }else {
            meEl = $("#"+me.name);
        }

        var ruleConfig = eval('(' + '{'+$P.gv(me.rule)+'}' + ')');
        $P.doElRule(ruleConfig,meEl);

        var paramConfig = eval('(' + '{'+$P.gv(me.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }

        if(!$P.isnullorempty(paramConfig.dic_code)){
            $P.initDropdownFromDic(meEl,paramConfig.dic_code,{
                idField: 'PARACODE',
                keyField: 'PARANAME',
                effectiveFields: ['PARANAME'],
                defaultValue: me.vobj[me.name],
                readonly:paramConfig.readonly == true,
                bEmpty:paramConfig.bEmpty == undefined ? false : paramConfig.bEmpty
            },function(data, e){
                if(paramConfig.callfun != undefined && (typeof paramConfig.callfun) == 'function'){
                    paramConfig.callfun.call(this,data);
                }else{
                    Vue.set(me.vobj, $P.gv(me.bind_name,me.name), data["id"])
                    meEl.attr("data-id", data["id"]);
                }
            });
        }else if(paramConfig.hasOwnProperty("config")){
            var callFun = paramConfig.callfun;
            if(callFun == null || callFun ==undefined){
                callFun = function(data, e){
                    Vue.set(me.vobj, $P.gv(me.bind_name,me.name), data["id"]);
                    meEl.attr("data-id", data["id"]);
                }
            }

            if(!$P.isnullorempty(me.vobj[me.name])){
                paramConfig.config.defaultValue=me.vobj[me.name];
            }

            if(paramConfig.readonly == true){
                paramConfig.config.readonly = true;
            }

            var postData = {};

            if(paramConfig.param != undefined && (typeof paramConfig.param ) == 'function'){
                $.extend(postData,paramConfig.param.call(me,me.vobj,me.name));
            }else if(paramConfig.param != undefined ){
                $.extend(postData,paramConfig.param);
            }
            $P.initDropdown(meEl,postData,paramConfig.config,callFun,paramConfig.url,me.vobj[me.name]);
        }else {

        }

        if(me.root != undefined && me.root.bREEvent == true){
            try{
                $(me.$el).keyup(function(event){
                    if(event.keyCode ==13 ){
                        me.root.enterEvent.call(this);
                        stopPropagation();
                    }
                });
            }catch (e){
                console.log("回车事件异常",e);
            }
        }
    }
});

Vue.component('dcselect3', {
    template:
    '<div class="input-group" style="width: 100%">'+
    '<select class="form-control" xtype="select3" :style="r_style"   isdropdown="true" :name="name" :id="r_id" :data-id="r_value" > </select>'+
    '</div>',
    data: function () {
        var paramConfig = eval('(' + '{'+$P.gv(this.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }


        return {
            r_readonly:paramConfig["readonly"] == true,
            r_style:$P.gv(paramConfig["style"]),
            r_value: this.vobj[this.name],
            r_id:$P.isnullorempty(this.id) ? this.name :this.id
        };
    },
    props: ['name','id','vobj','rule','param','paramobj','root','bind_name','row','use_id'], //接收一个 value prop
    methods: {
        handleInput:function(event) {
            var value = event.target.value.forbiddenWord();
            this.vobj[this.name]=value;
        }
    },
    mounted:function(){
        if(this.row && !$P.isnullorempty(this.row["DEFALUT_VALUE"])){
            var defaultValue = this.row["DEFALUT_VALUE"];
            if(defaultValue.indexOf("fun=") >=0){
                defaultValue = defaultValue.replace("fun=","");
                defaultValue = eval(defaultValue);
                Vue.set(this.vobj,this.name,defaultValue);
            }else{
                Vue.set(this.vobj,this.name,this.row["DEFALUT_VALUE"]);
            }
        }


        var me = this;
        var meEl;

        if(this.use_id != true && this.root && this.root.$el){
            //meEl = $(this.root.$el).find("#"+me.name);
            meEl = $("#"+this.root.id+" #"+me.name)
        }else {
            meEl = $("#"+me.name);
        }



        var ruleConfig = eval('(' + '{'+$P.gv(me.rule)+'}' + ')');
        $P.doElRule(ruleConfig,meEl);

        var paramConfig = eval('(' + '{'+$P.gv(me.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }

        if(!$P.isnullorempty(paramConfig.dic_code)){
            $P.select3FromDic(meEl,paramConfig.dic_code,{
                idField: 'PARACODE',
                keyField: 'PARANAME',
                effectiveFields: ['PARANAME'],
                defaultValue: me.vobj[me.name],
                readonly:paramConfig.readonly == true,
                multiple:paramConfig.multiple == true,
            },function(e){
                if(paramConfig.callfun != undefined && (typeof paramConfig.callfun) == 'function'){
                    paramConfig.callfun.call(this,e);
                }else{
                    if(paramConfig.multiple){
                        var ay = me.vobj[$P.gv(me.bind_name,me.name)];
                        if(ay == undefined){
                            ay = [];
                        }
                        ay.push(e.params.data.id);
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), ay);
                    }else {
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), e.params.data.id);
                    }

                    // Vue.set(me.vobj, $P.gv(me.bind_name,me.name), data["id"])
                    //meEl.attr("data-id", data["id"]);
                }
            }
            ,function (e) {
                    if(paramConfig.multiple){
                        var ay = me.vobj[$P.gv(me.bind_name,me.name)];
                        if(ay == undefined){
                            ay = [];
                        }
                        ay.splice(ay.valueIndexOf(e.params.data.id),1)
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), ay);
                    }else {
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), "");
                    }
                }
            );
        }else if(paramConfig.hasOwnProperty("config")){
            if(paramConfig.readonly == true){
                paramConfig.config.readonly = true;
            }

            if(paramConfig.multiple == true){
                paramConfig.config.multiple = true;
            }


            var callFun = paramConfig.callfun;
            if(callFun == null || callFun ==undefined){
                callFun = function(e){
                    if(paramConfig.config.multiple){
                        var ay = me.vobj[$P.gv(me.bind_name,me.name)];

                        if(ay == undefined ||  (typeof ay) == 'string' ){
                            ay = [];
                        }
                        ay.push(e.params.data.id);
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), ay);
                    }else {
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), e.params.data.id);
                    }
                }
            }

            var unselectCallFun = paramConfig.unselectCallFun;
            if(unselectCallFun == null || unselectCallFun ==undefined){
                unselectCallFun = function(e){
                    if(paramConfig.config.multiple){
                        var ay = me.vobj[$P.gv(me.bind_name,me.name)];
                        if(ay == undefined){
                            ay = [];
                        }
                        ay.splice(ay.valueIndexOf(e.params.data.id),1)
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), ay);
                    }else {
                        Vue.set(me.vobj, $P.gv(me.bind_name,me.name), "");
                    }
                }
            }

            if(!$P.isnullorempty(me.vobj[me.name])){
                paramConfig.config.defaultValue=me.vobj[me.name];
            }



            var postData = {};

            if(paramConfig.param != undefined && (typeof paramConfig.param ) == 'function'){
                $.extend(postData,paramConfig.param.call(me,me.vobj,me.name));
            }else if(paramConfig.param != undefined ){
                $.extend(postData,paramConfig.param);
            }

            $P.select3(meEl,postData,paramConfig.config,callFun,paramConfig.url,unselectCallFun);
        }else {

        }
    }
});

Vue.component('dcdate', {
    template: '<input type="text" :name="name" autocomplete="off" :id="r_id" class="form-control" v-model="vobj[name]" :value="r_value" @input="handleInput"/>',
    data: function () {
        return {
            r_value: this.vobj[this.name],
            r_id:$P.isnullorempty(this.id) ? this.name :this.id
        };
    },
    props: ['name','id','vobj','rule','param','paramobj','row','root','use_id'], //接收一个 value prop
    methods: {
        handleInput:function(event) {
            var value = event.target.value.forbiddenWord();
            this.vobj[this.name]=value;
            //this.$emit('input', value); //触发 input 事件，并传入新值
        }
    },
    mounted:function(){
        var paramConfig = eval('(' + '{'+$P.gv(this.param)+'}' + ')');
        if(this.paramobj != undefined){
            $.extend(paramConfig,this.paramobj);
        }

        if(this.row && !$P.isnullorempty(this.row["DEFALUT_VALUE"])){
            var defaultValue = this.row["DEFALUT_VALUE"];
            if(defaultValue.indexOf("fun=") >=0){
                defaultValue = defaultValue.replace("fun=","");
                defaultValue = eval(defaultValue);
                Vue.set(this.vobj,this.name,defaultValue);
            }else{
                Vue.set(this.vobj,this.name,this.row["DEFALUT_VALUE"]);
            }

            /*var obj=eval('(' + '{'+this.row["DEFALUT_VALUE"]+'}' + ')');
             if(!obj.defaultValue||!obj.formatDate){
             var defaultValue=obj.defaultValue;
             var formatDate=obj.formatDate;
             if(!$P.isnullorempty(defaultValue)){
             Vue.set(this.vobj,this.name,defaultValue);
             }
             else{
             if(!$P.isnullorempty(formatDate)){
             Vue.set(this.vobj,this.name,new Date().format(formatDate));
             }
             else{
             Vue.set(this.vobj,this.name,new Date().format());
             }
             }
             }
             else{
             Vue.set(this.vobj,this.name,this.row["DEFALUT_VALUE"]);
             }*/
        }

        var me = this;
        var dateConfig = $.extend( {
            elem: '#'+me.r_id,
            ismonth: true,
            choose: function (dates) {
                Vue.set(me.vobj, me.name, dates);
            }
        },(paramConfig.hasOwnProperty("config") ? paramConfig.config:{}));

        laydate(dateConfig);

        var ruleConfig = eval('(' + '{'+$P.gv(me.rule)+'}' + ')');
        $P.doElRule(ruleConfig,$(this.$el));
    }
});

Vue.component('dclab', {
    template: '<label :class="dclass" :for="dfor" :style="dstyle">'+
    '<div style="display: flex;justify-content:space-between;"  >' +
    '<span v-for="word in labs">{{word}}</span>' +
    '</div>' +
    '</label>',
    data: function () {
        var ay = this.lab.split("");
        var len = ay.length;

        if(ay[len-1] == ":" || ay[len - 1] == "："){
            ay[len-2] = ay[len-2]+":";
        }
        ay.splice(len-1,1);

        return {
            labs:ay
        }
    },
    props: ['lab','dfor','dclass','dstyle','row']
});

Vue.component('dcconfigbtn', {
    template:
    ' <button :id="id == null ? \'configQueryPage\' :id " type="button" class="btn btn-warning " style="margin-left: 2px;">'+
    '<i class="glyphicon glyphicon-cog" aria-hidden="true" ></i>&nbsp;{{button_text == null ? "页面配置" : button_text}}'+
    '</button>',
    data: function () {
        return {

        };
    },
    props:{
        "page_id":{type: String,required: true},
        "grid_id":{type: String},
        "form_id":{type: String},
        "button_text":{type: String},
        "id":{type: String},
        "display":{type: String},/*显示哪些内容*/
        "target":{type: String},
        "show_status":{type: String},
    },
    methods: {

    },
    mounted:function(){
        var id = this.id;
        var pageId = this.page_id;
        var gridId = $P.gv(this.grid_id);;
        var formId = $P.gv(this.form_id);
        var showStatus = $P.gv(this.show_status);
        var display = $P.gv(this.display);
        var target = $P.gv(this.target);


        $("#"+$P.gv(id,"configQueryPage")).click(function(){
            if(target == "_top"){
                top.open('/khff/Resources/templates/SystemMgr/syPageConfig/syPageConfigMain.html?SHOW_STATUS='+showStatus+'&GRID_ID='+gridId+'&PAGE_ID='+pageId+'&FORM_ID='+formId+'&DISPLAY='+display+'&_dc=' + Math.random());
                return ;
            }

            layer.open({
                type: 2,//弹出层类型
                title: '页面配置管理',//弹出层标题
                shadeClose: false,
                shade: 0.3,//透明度
                id: 'addSyConfigWindow',
                resize: true,
                area: ['99%', '99%'],//大小
                shift: 5,
                success: function (layero, index) {

                },
                content: ['/khff/Resources/templates/SystemMgr/syPageConfig/syPageConfigMain.html?SHOW_STATUS='+showStatus+'&GRID_ID='+gridId+'&PAGE_ID='+pageId+'&FORM_ID='+formId+'&DISPLAY='+display+'&_dc=' + Math.random(), 'yes'],
                end: function () {

                }
            });
        });
    }
});


Vue.component("dcexportbtn",{
    template:
    '<div :id="r_id" class="export btn-group" style="padding-top: 0px !important;padding-bottom: 0px !important;">' +
    '<template v-if="!is_single">'+
    '<button class="btn btn-default btn-outline dropdown-toggle" aria-label="export type" title="Export data"'+
    'data-toggle="dropdown" type="button">' +
    '<i class="glyphicon glyphicon-export icon-share"></i>导出'+
    '<span class="caret" ></span>' +
    '</button>'+
    '<ul class="dropdown-menu" role="menu">'+
    '<li v-for="(config,index) in excportConfigs"  v-on:click="exportItemClick(config,index)" role="menuitem" data-type="excel"><a href="javascript:void(0)">{{config.EXPORT_NAME}}</a></li>'+
    '</ul>' +
    '</template>' +
    '<template v-else>' +
    '<button class="btn btn-default btn-outline dropdown-toggle" aria-label="export type" title="Export data"'+
    'data-toggle="dropdown" type="button"  v-on:click="exportItemClick(custConfig,0)">' +
    '<i class="glyphicon glyphicon-export icon-share"></i>{{custConfig.EXPORT_NAME}}'+
    '</button>'+
    '</template>'+
    '</div>',

    data:function(){
        var excportConfigs =$P.getExportConfig(this.page_id,this.grid_id);

        if(this.show_default == true){
            excportConfigs.push({
                GRID_ID:this.grid_id,
                PAGE_ID:this.page_id,
                EXPORT_ID:"default",
                EXPORT_NAME:$P.gv(this.export_name,"默认Excel"),
                FILE_NAME:$P.gv(this.default_file_name,"默认Excel"),
                SERVICE_NAME:$P.gv(this.service_name,excportConfigs.length > 0 ? excportConfigs[0].SERVICE_NAME:"")
            });
        }

        var custConfig = excportConfigs.findFirst("EXPORT_ID",this.export_id);

        return {
            is_single:this.single == true || !$P.isnullorempty(this.export_id),
            excportConfigs:excportConfigs,
            r_id:$P.gv(this.id,"dcexportbtn"),
            custConfig:custConfig
        };

    },
    props:{
        "id":{type:String},
        "default_file_name":{type:String},
        "page_id":{required:true,type:String},
        "single":{type:Boolean},
        "grid_id":{required:true,type:String},
        "service_name":{type:String},
        "export_id":{type:String},
        "export_name":{type:String},
        "condition":{required:true},
        "show_default":{type:Boolean},
        "call_back":{type:Function},
        "sync_call_back":{type:Function},
    },
    methods:{
        exportItemClick:function(config,index){
            var param = this.condition;
            if(this.call_back != undefined){
                var rs = this.call_back.call(this,config,param);
                if(rs == false){
                    return ;
                }else if(rs.hasOwnProperty("param")){
                    param = rs["param"]
                }else {
                    param = rs;
                }
            }

            var task = function(){
                config["serviceName"] = config.SERVICE_NAME;//this.service_name;
                config["FILE_NAME"] = $P.gv(config.FILE_NAME,config.EXPORT_NAME)

                var fileLastName = "xlsx";
                app.callAjaxPost("/khff/api/common/exportExcel", {"config": config,condition:param,GRID_PLAN:$P.gv(app.getUrlParam('GRID_PLAN'),"")}, function (result) {
                    if(result.success){

                        if(!$P.isnullorempty(result.data.downFileName) && result.data.downFileName.toLowerCase().endsWith("xls")){
                            fileLastName = "xls";
                        }
                        var downUrl = API_HOST + "/khff/api/common/downLoadFile?filename=" + config["FILE_NAME"] + "." + fileLastName + "&downloadname=" + result.data.downFileName + "&token=" + app.getCookie('token');
                        window.location.href = downUrl;
                        //top.window.open(downUrl);
                    }else {
                        layer.alert($P.gv(result.message,$P.getDefaultErrorMsg()), {icon: 2});
                    }
                },this,true);
            }

            //同步执行
            if(this.sync_call_back != undefined){
                var dtd = $.Deferred();
                var me = this;
                $.when(me.sync_call_back.call(me,config,param,dtd)).done(function () {
                    task();
                });
            }else {
                task();
            }


        }
    },
    mounted:function () {

    },
    destroyed:function(){

    }
});

Vue.component("dcimportbtn",{
    template:
    '<div :id="r_id" class="export btn-group" style="padding-top: 0px !important;padding-bottom: 0px !important;">' +
    '<template v-if="!is_single">'+
    '<button class="btn btn-default btn-outline dropdown-toggle" aria-label="export type" title="Export data"'+
    'data-toggle="dropdown" type="button">' +
    '<i class="glyphicon glyphicon-import icon-share"></i>导入'+
    '<span class="caret"></span>' +
    '</button>'+
    '<ul class="dropdown-menu" role="menu">'+
    '<li v-for="(config,index) in importConfigs"   role="menuitem" data-type="excel">' +
    '<a style="display: table-cell;width: 200px;" href="javascript:void(0)" v-on:click="importItemClick(config,index)">{{config.IMPORT_NAME}}</a>' +
    '<a style="display: table-cell;width: 50px;" class="a-border-left" v-on:click="downTemplate(config,index)">下载模板</a>' +
    '</li>'+
    '</ul>' +

    '</template>' +
    '<template v-else>' +
    '<button class="btn btn-default btn-outline dropdown-toggle" aria-label="export type" title="Export data"'+
    'data-toggle="dropdown" type="button" v-on:click="importItemClick(custConfig,0)">' +
    '<i class="glyphicon glyphicon-import icon-share"></i>{{custConfig.IMPORT_NAME}}'+
    '</button>'+
    '</template>'+
    '<div style="display: none;padding-top: 50px" :id="r_id+\'_eport_div\'" >' +
    '<div class="panel dc-form dc-panel panel-default" style="border: medium none;">' +
    '<div class="panel-body">' +
    '<div class="form-group">' +
    '<div class="col-sm-12">' +
    '<div class="input-group" style="width: 100%">' +
    '<input :id="r_id+\'_file\'" name="IMPORT_FILE" type="file" style="display:none">'+
    '<input :id="r_id+\'_filename\'" name="filename" required readonly style="background-color: #ffffff; height: 25px" class="form-control" type="text">'+
    '<span class="input-group-addon" :id="r_id+\'_pick\'" style="cursor: pointer; background-color: #e7e7e7">'+
    '<i class="fa fa-folder-open"></i>选择文件'+
    '</span>' +
    '</div>' +
    '</div>' +
    '</div>' +
    '</div>' +
    '</div>' +
    '</div>' +
    '</div>',

    data:function(){
        var importConfigs =$P.getImportConfig(this.page_id,this.grid_id);
        if(this.show_default == true) {
            importConfigs.push({
                GRID_ID: this.grid_id,
                PAGE_ID: this.page_id,
                IMPORT_ID: "",
                IMPORT_NAME: "默认Excel",
                FILE_NAME: $P.gv(this.default_file_name, "默认Excel")
            });
        }

        var custConfig = importConfigs.findFirst("IMPORT_ID",this.import_id);

        return {
            is_single:!$P.isnullorempty(this.import_id),
            importConfigs:importConfigs,
            r_id:$P.gv(this.id,"dcimportbtn"),
            custConfig:custConfig
        };

    },
    props:{
        "id":{type:String},
        "default_file_name":{type:String},
        "page_id":{required:true,type:String},
        "grid_id":{required:true,type:String},
        "service_name":{type:String},
        "condition":{required:true},
        "import_id":{type:String},
        "show_default":{type:Boolean},
        "succ_fun":{type:Function},
        "call_back":{type:Function},
    },
    methods:{
        downTemplate:function (config,index) {
            config["serviceName"] = this.service_name;
            config["FILE_NAME"] = $P.gv(config.FILE_NAME,config.IMPORT_NAME)


            app.callAjaxPost("/khff/api/common/downTemplate", {"config": config,condition:this.condition}, function (result) {
                if(result.success){
                    var downUrl = API_HOST + "/khff/api/common/downLoadFile?filename=" + config["FILE_NAME"] + ".xlsx&downloadname=" + result.data.downFileName + "&token=" + app.getCookie('token');
                    window.location.href = downUrl;
                    //top.window.open(downUrl);
                }
            },this,true);
        },
        importItemClick:function(config,index){
            var layId = this.r_id+"_eport_div";
            var r_id = this.r_id;
            var page_id = this.page_id;
            var grid_id = this.grid_id;
            var succ_fun = this.succ_fun;
            var call_back = this.call_back;
            var service_name = config.SERVICE_NAME;//this.service_name;
            $('#'+r_id+'_filename').val("");
            $('#'+r_id+'_file').val("");

            var index2 = layer.open({
                id:'data-import',
                skin:'layui-dc',
                type: 1,
                title: 'Excel导入',
                shadeClose: true,
                shade: 0.3,
                area: ['400px', '300px'],
                content: $("#"+layId),
                btn: ['确认导入', '取消'],
                yes:function (index, layero) {
                    if($P.isnullorempty($('#'+r_id+'_filename').val())){
                        layer.alert('请选择要上传的文件', {icon: 2});
                        return ;
                    }

                    var form = new FormData();
                    form.append("FILE_NAME", $('#'+r_id+'_filename').val());
                    form.append("file", $('#'+r_id+'_file')[0].files[0]);
                    form.append("PAGE_ID",page_id);
                    form.append("GRID_ID", grid_id);
                    form.append("SERVICE_NAME", service_name);
                    form.append("IMPORT_ID", config.IMPORT_ID);
                    form.append("GRID_PLAN", $P.gv(app.getUrlParam('GRID_PLAN'),""));
                    if(call_back != undefined) {
                        var rs = call_back.call(this, form);
                        if(rs == false){
                            return ;
                        }
                    }

                    var loadingIndex = loading();
                    loadingIndex.show();
                    app.callAjaxPost4UpLoad(API_HOST + "/khff/api/common/importExcel", form, function (result) {
                        if ((typeof result) == 'string') {
                            result = eval('(' + result + ')');
                        }

                        loadingIndex.close();
                        if (result.success) {
                            var index3 = layer.alert("上传数据成功！", { icon: 1 }, function () {
                                layer.close(index2);
                                layer.close(index3);
                            });

                            if (succ_fun != undefined) {
                                succ_fun.call(this, result);
                            }
                        } else {
                            //弹出上传错误信息
                            if (!$P.isnullorempty(result.data)) {
                                $P.tempData["errorImportData"] = result.data;
                                layer.open({
                                    type: 2,//弹出层类型
                                    title: '数据导入校验结果',//弹出层标题
                                    shadeClose: true,
                                    shade: 0.5,//透明度
                                    area: ['55%', '65%'],//大小
                                    shift: 5,
                                    content: ['/khff/Resources/templates/common/import/errorMsgShow.html?_dc=' + Math.random(), 'yes'],
                                    end: function () {
                                        //grid.queryData();

                                    }
                                });
                            }
                            else {
                                if(result.message) layer.alert(result.message, { icon: 2 });
                                else layer.alert("上传出现错误，请重试", { icon: 2 });
                            }
                        }
                    }, function () {
                        loadingIndex.close();
                        layer.alert("上传出现错误，请重试", { icon: 2 });
                        // window.clearInterval(timer);
                    })

                },
                btn2:function(index, layero){
                    layer.close(index)
                }
            });
        }
    },
    mounted:function () {
        //选择文件按钮
        var r_id = this.r_id;
        $('#'+r_id+'_pick').bind('click', function () {
            $('#'+r_id+'_file').click();
        });

        //监听文件上传对话框的onchange事件
        $('#'+r_id+'_file').bind('change', function () {
            var $inputFile = $('#'+r_id+'_file');
            var filePath = $inputFile.val();
            var fileName = filePath.substring(filePath.lastIndexOf('\\') + 1);
            var lastName = fileName.substring(fileName.lastIndexOf('.') + 1);
            if (lastName == 'xls' || lastName == 'xlsx' ) {
                $('#'+r_id+'_filename').val(filePath.substring(filePath.lastIndexOf('\\') + 1));
            } else if(!$P.isnullorempty(fileName)){
                layer.alert('请选择Excel文件', {icon: 2});
            }
        });
    },
    destroyed:function(){

    }
});

Vue.component("dcprintbtn",{
    template:
    '<div :id="r_id" class="export btn-group" style="padding-top: 0px !important;padding-bottom: 0px !important;">'+
    '<button class="btn btn-default btn-outline dropdown-toggle" aria-label="export type" title="Export data"'+
    'data-toggle="dropdown" type="button">' +
    '<i class="glyphicon glyphicon-print icon-share"></i>打印'+
    '<span class="caret"></span>' +
    '</button>'+
    '<ul class="dropdown-menu" role="menu">'+
    '<li v-for="(config,index) in printConfigs"  v-on:click="printItemClick(config,index)" role="menuitem" data-type="excel"><a href="javascript:void(0)">{{config.REPORT_NAME}}</a></li>'+
    '</ul>'+
    '</div>',

    data:function(){
        var printConfigs =$P.getPrintConfig(this.page_id);

        return {
            printConfigs:printConfigs,
            r_id:$P.gv(this.id,"dcprintbtn")
        };

    },
    props:{
        "id":{type:String},
        "page_id":{required:true,type:String},
        "service_name":{type:String},
        "get_print_param":{type:Function},
        "getprintparam":{type:Function}
    },
    methods:{
        printItemClick:function(config,index){
            var reportUrl = REPORT_HOST+"/report/ReportServer?reportid=" + config.REPORT_ID + "&token=" + app.getCookie('token');
            if(this.get_print_param != undefined && (typeof this.get_print_param) == 'function'){
                var rsObj = this.get_print_param.call(this,config,index);
                if(rsObj == false){
                    return;
                }
                reportUrl += $P.json2UrlForReport(rsObj);
            }
            window.open(reportUrl);
        }
    },
    mounted:function () {

    },
    destroyed:function(){

    }
});

Vue.component("dcbtn",{
    template:
        '<button  :class="r_class" aria-label="btn type" v-bind:disabled="r_disabled" :id="id" data-toggle="dropdown" type="button" :style="r_style">' +
            '<i :class="icon"></i>{{r_text}}'+
            // '<span class="caret"></span>' +
        '</button>',

    data:function(){
        var r_show = this.show;
        var r_fun_code = $P.gv(this.fun_code,this.id);
        var r_fun_name = $P.gv(this.fun_name,this.text);
        var r_check = this.check;
        var r_style = $P.gv(this.style,"");
        var r_disabled = false;
        var r_text = $P.gv(this.text,this.fun_name);
        var r_class = $P.gv(this.class,"btn btn-default btn-outline dropdown-toggle");

        var hasPrivilege = (!r_check || $P.hasPrivilege(this.page_id,r_fun_code));

        //console.log($P.hasPrivilege(this.page_id,r_fun_code),r_fun_code);

        if(!hasPrivilege){
            if(r_show){
                r_disabled = true;
            }else {
                r_style+=";display:none;"
            }
        }

        return {
            hasPrivilege:hasPrivilege,
            r_show:r_show,
            r_class:r_class,
            r_text:r_text,
            r_fun_code:r_fun_code,
            r_fun_name:r_fun_name,
            r_style:r_style,
            r_disabled:r_disabled
        };

    },
    props:{
        "id":{required:true,type:String},
        "text":{required:true,type:String},
        "page_id":{required:true,type:String},//页面id
        "fun_code":{type:String},//功能编号
        "fun_name":{type:String},//功能名称
        "show":{type:Boolean,default:false},//无权限是否显示
        "check":{type:Boolean,default:true},//是否检查权限,默认检查
        "icon":{type:String},//按钮图标
        "class":{type:String},//按钮class

    },
    methods:{
        printItemClick:function(config,index){

        }
    },
    mounted:function () {

    },
    destroyed:function(){

    }
});

Vue.component('dcquery', {
    template:
    '<div class="btn-group" v-if="bDropdown" :id="btngroupId">'+
    '<button class="btn btn-primary buttonColor btnSize" type="button" :id="id">'+
    '<i class="glyphicon glyphicon-search" aria-hidden="true"></i>&nbsp;'+
    '查询'+
    '</button>'+
    '<button type="button" class="btn btn-danger dropdown-toggle dc-dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"  :title="r_title">'+
    '<span class="caret"></span>'+
    '<span class="sr-only" >Toggle Dropdown</span>'+
    '</button>'+
    '<ul class="dropdown-menu" >'+
    '<li  v-for="conplan in CON_PLANS">' +
    '<a href="#" id="aconplan" :style="_style(conplan.CON_PLAN) " :conplan="conplan.CON_PLAN">{{conplan.CON_PLAN}}</a>' +
    '</li>'+
    '</ul>'+
    '</div>' +
    '<button v-else class="btn btn-primary buttonColor btnSize" type="button" :id="id">'+
    '<i class="glyphicon glyphicon-search" aria-hidden="true"></i>&nbsp;'+
    '查询'+
    '</button>',

    data: function () {
        var bDropdown = false;
        var curConPlan=app.getUrlParam("CON_PLAN");

        if(!$P.isnullorempty(this.page_id) && !$P.isnullorempty(this.grid_id)){
            var CON_PLANS = $P.getPageConditionCofnig(this.page_id,this.grid_id,true)["CON_PLANS"];
            if($.isArray(CON_PLANS) && CON_PLANS.length >1){
                bDropdown = true;
            }
        }

        return{
            r_title:"查询条件方案【"+curConPlan+"】",
            curConPlan:curConPlan,
            bDropdown:bDropdown,
            CON_PLANS:CON_PLANS,
            btngroupId:this.id+"_div"
        }
    },
    props: ['id','page_id','grid_id'],
    methods: {
        _style:function(conPlan){
            if($P.isnullorempty(this.curConPlan)) {
                return "";
            }

            if(this.curConPlan == conPlan){
                return "background-color:#679ED2;";
            }
        }
    },
    mounted:function(){
        $("#"+this.btngroupId).find("a[id=aconplan]").click(function () {
            var url = location.origin+location.pathname;
            var urlParam = app.getUrlParams();
            urlParam["CON_PLAN"] = $(this).attr("conplan");
            window.location.href = url + "?" + app.json2Url(urlParam) + "&token=" + app.getCookie('token');
        });
    }
});


Vue.component('gridfilter', {
    template:
    '<div :id="id" style="padding: 10px 10px;display: none;" >' +
    '<input type="checkbox" :id="id+\'_all\'" :checked="select_titles!=undefined && titles.length == select_titles.length"  />'+
    '<label :for="id+\'_all\'" style="padding-left: 5px;margin-bottom: 0px" >全部</label>' +
    '<ul class="ul-p0">'+
    '<li  v-for="(title,index) in titles" style="padding: 1px 1px;list-style-type:none;">' +
    '<input type="checkbox" :value="title" :index="index" :id="id+index" v-on:click="ckClick(id+\'_ck\',title)" :name="id+\'_ck\'"  :checked="select_titles!=undefined && select_titles.contains(title)" />'+
    '<label :for="id+index" style="padding-left: 5px;margin-bottom: 0px" >{{title}}</label>' +
    '</li>'+
    '</ul>'+
    '</div>',

    data: function () {
        return {
        }
    },
    props: ['id','titles','select_titles'],
    methods: {
        ckClick:function (ckName,title) {
            var that = this;
            that.select_titles.splice(0,that.select_titles.length);
            $("#"+this.id).find("input[name="+ckName+"]:checked").each(function (index,el) {
                var selectValue = $(el).val();
                that.select_titles.push(selectValue);
            });
        }
    },
    mounted:function(){
        var that = this;
        $('.ul-p0').css('padding-left','0px')
        $("#"+that.id+"_all").click(function(){
            var bChecked = $(this).is(":checked");
            if(bChecked){
                that.select_titles.splice(0,that.select_titles.length);
                that.titles.forEach(function (val) {
                    that.select_titles.push(val);
                });
            }else {
                that.select_titles.splice(0,that.select_titles.length);
            }
        })
    }
});






