(function ($) {
  'use strict';
  var flag1 = true;
  var sprintf = function (str) {
      var args = arguments,
          flag = true,
          i = 1;

      str = str.replace(/%s/g, function () {
          var arg = args[i++];

          if (typeof arg === 'undefined') {
              flag = false;
              return '';
          }
          return arg;
      });
      return flag ? str : '';
  };

  $.extend($.fn.bootstrapTable.defaults, {
      leftFixedColumns: false,
      leftFixedNumber: 1,
      rightFixedColumns: false,
      rightFixedNumber: 1
  });

  var BootstrapTable = $.fn.bootstrapTable.Constructor,
      _initHeader = BootstrapTable.prototype.initHeader,
      _initBody = BootstrapTable.prototype.initBody,
      _resetView = BootstrapTable.prototype.resetView;

  BootstrapTable.prototype.initFixedColumns = function () {
      this.timeoutHeaderColumns_ = 0;
      this.timeoutBodyColumns_ = 0;
      if (this.options.leftFixedColumns) {
          this.$fixedHeader = $([
              '<div class="fixed-table-header-columns">',
              '<table>',
              '<thead></thead>',
              '</table>',
              '</div>'].join(''));

          this.$fixedHeader.find('table').attr('class', this.$el.attr('class'));
          this.$fixedHeaderColumns = this.$fixedHeader.find('thead');
          this.$tableHeader.before(this.$fixedHeader);

          this.$fixedBody = $([
              '<div class="fixed-table-body-columns">',
              '<table>',
              '<tbody></tbody>',
              '</table>',
              '</div>'].join(''));

          this.$fixedBody.find('table').attr('class', this.$el.attr('class'));
          this.$fixedBodyColumns = this.$fixedBody.find('tbody');
          this.$tableBody.before(this.$fixedBody);
      
      }
      if (this.options.rightFixedColumns) {
          this.$rightfixedHeader = $([
              '<div class="fixed-table-header-columns" style="right:0px;top:0;z-index:101;">',
              '<table>',
              '<thead></thead>',
              '</table>',
              '</div>'].join(''));

          this.$rightfixedHeader.find('table').attr('class', this.$el.attr('class'));
          this.$rightfixedHeaderColumns = this.$rightfixedHeader.find('thead');
          this.$tableHeader.before(this.$rightfixedHeader);
          this.$rightfixedBody = $([
              '<div class="fixed-table-body-columns" style="right:0px;top:1px;z-index:100;">',
              '<table>',
              '<tbody></tbody>',
              '</table>',
              '</div>'].join(''));

          this.$rightfixedBody.find('table').attr('class', this.$el.attr('class'));
          this.$rightfixedBodyColumns = this.$rightfixedBody.find('tbody');
          this.$tableBody.before(this.$rightfixedBody);
      }
  };

  BootstrapTable.prototype.initHeader = function () {
      _initHeader.apply(this, Array.prototype.slice.apply(arguments));

      if (!this.options.leftFixedColumns && !this.options.rightFixedColumns) {
          return;
      }
      this.initFixedColumns();

      var $tr = this.$header.find('tr:eq(0)').clone(),
          $ths = $tr.clone().find('th');

      //$tr.html('');
      //左边列冻结
      if (this.options.leftFixedColumns) {
          var $newtr = $('<tr></tr>');
          $newtr.attr('data-index', $tr.attr('data-index'));
          $newtr.attr('data-uniqueid', $tr.attr('data-uniqueid'));
          for (var i = 0; i < this.options.leftFixedNumber; i++) {
              $newtr.append($ths.eq(i).clone());
          }
          this.$fixedHeaderColumns.html('').append($newtr);
      }
      //$tr.html('');
      //右边列冻结
      if (this.options.rightFixedColumns) {
          var $newtr2 = $('<tr></tr>');
          $newtr2.attr('data-index', $tr.attr('data-index'));
          $newtr2.attr('data-uniqueid', $tr.attr('data-uniqueid'));
          for (var i = 0; i < this.options.rightFixedNumber; i++) {
              $newtr2.append($ths.eq($ths.length - this.options.rightFixedNumber + i).clone());
          }
          this.$rightfixedHeaderColumns.html('').append($newtr2);
      }
  };

  BootstrapTable.prototype.initBody = function () {
      _initBody.apply(this, Array.prototype.slice.apply(arguments));

      if (!this.options.leftFixedColumns && !this.options.rightFixedColumns) {
          return;
      }
      var that = this;
      if (this.options.leftFixedColumns) {
          this.$fixedBodyColumns.html('');
          this.$body.find('> tr[data-index]').each(function () {
              var $tr = $(this).clone(),
                  $tds = $tr.clone().find('td');

              $tr.html('');
              for (var i = 0; i < that.options.leftFixedNumber; i++) {
                  $tr.append($tds.eq(i).clone());
              }
              that.$fixedBodyColumns.append($tr);
          });
          if(that.$fixedBodyColumns.parent().find("thead").length == 0){
              that.$fixedBodyColumns.parent().prepend(that.$fixedHeader.find("table").html());
          }
          var fieldIndex = 0;
              for(var i =0;i<that.columns.length;i++){
              fieldIndex += 1;
              var events = window.openEvent;
              for (var key in events) {
                  that.$fixedBody.find('tr').each(function () {
                      var $tr = $(this),
                          $td = $tr.find(that.options.cardView ? '.card-view' : 'td').eq(fieldIndex),
                          index = key.indexOf(' '),
                          name = key.substring(0, index),
                          el = key.substring(index + 1),
                          func = events[key];
      
                      $td.find(el).off(name).on(name, function (e) {
                          var index = $tr.data('index'),
                              row = that.data[index];
                              // value = row[field];
      
                          func.apply(this, [e, "", row, index]);
                      });
                  });
              }
          }
      }
      if (this.options.rightFixedColumns) {
          this.$rightfixedBodyColumns.html('');
          this.$body.find('> tr[data-index]').each(function () {
              var $tr = $(this).clone(),
                  $tds = $tr.clone().find('td');
              $tr.html('');
              for (var i = 0; i < that.options.rightFixedNumber; i++) {
                  var indexTd = $tds.length - that.options.rightFixedNumber + i;
                  var oldTd = $tds.eq(indexTd);
                  var fixTd = oldTd.clone();
                  var buttons = fixTd.find('button');
                  //事件转移：冻结列里面的事件转移到实际按钮的事件
                  buttons.each(function (key, item) {
                      $(item).click(function () {
                          that.$body.find("tr[data-index=" + $tr.attr('data-index') + "] td:eq(" + indexTd + ") button:eq(" + key + ")").click();
                      });
                  });
                  $tr.append(fixTd);
              }
              that.$rightfixedBodyColumns.append($tr);
          });
          if(that.$rightfixedBodyColumns.parent().find("thead").length == 0){
              that.$rightfixedBodyColumns.parent().prepend(that.$rightfixedHeader.find("table").html());
          }
          var fieldIndex = 0;
          for(var i =0;i<that.columns.length;i++){
              fieldIndex += 1;
              var events = window.openEvent;
              for (var key in events) {
                  that.$rightfixedBody.find('tr').each(function () {
                      var $tr = $(this),
                          $td = $tr.find(that.options.cardView ? '.card-view' : 'td').eq(fieldIndex),
                          index = key.indexOf(' '),
                          name = key.substring(0, index),
                          el = key.substring(index + 1),
                          func = events[key];
      
                      $td.find(el).off(name).on(name, function (e) {
                          var index = $tr.data('index'),
                              row = that.data[index];
                              // value = row[field];
      
                          func.apply(this, [e, '', row, index]);
                      });
                  });
              }
          }
      }
      this.$selectItem = this.$body.find(sprintf('[name="%s"]', this.options.selectItemName));
      if (this.options.leftFixedColumns) {
          this.$selectItem1 = that.$fixedBodyColumns.find(sprintf('[name="%s"]', this.options.selectItemName));
          this.$fixedBodyColumns.find('> tr[data-index] > td').off('click').on('click', function () {
              var idx = $(this).parents("tr").attr("data-index");
              that.$selectItem1.eq(idx).click();
          });
          this.$selectItem1.off('click').on('click', function (event) {
              flag1 = false;
              var idx = $(this).parents("tr").attr("data-index");
              that.$selectItem.eq(idx).click();
              var bfromtd = $(this).data("fromtd");
              $(this).removeData("fromtd");
              event.stopImmediatePropagation();
              var $this = $(this),
                  checked = $this.prop('checked'),
                  data_index = $this.data('index'),
                  row = that.data[data_index];
  
              if (that.options.maintainSelected && $(this).is(':radio')) {
                  $.each(that.options.data, function (i, row) {
                      row[that.header.stateField] = false;
                  });
              }
  
              row[that.header.stateField] = checked;
  
              //处理分组选中
              if(row["isGroupRow"] == true && that.options.groupSelect == true ){
                  var loop = true;
                  var GROUP_INDEX = row["GROUP_INDEX"];
                  while (GROUP_INDEX !=undefined && data_index < that.data.length &&  loop ){
                      data_index++;
  
                      var nextRow = that.data[data_index]
                      if(nextRow == undefined){break; }
                      loop = GROUP_INDEX == nextRow["GROUP_INDEX"];
  
                      if(loop){
                          nextRow[that.header.stateField] = checked;
                          if(checked == true){
                              that.$selectItem.eq(data_index).prop("checked",true).attr("checked",true);
                          }else{
                              that.$selectItem.eq(data_index).prop("checked",false).removeAttr("checked");
                          }
                      }
                  }
              }
  
              if (that.options.singleSelect || (bfromtd && that.options.clickSingleSelect)) {
                  that.$selectItem.not(this).each(function () {
                      that.data[$(this).data('index')][that.header.stateField] = false;
                  });
                  that.$selectItem.filter(':checked').not(this).prop('checked', false);
              }
              // that.updateSelected();
              // that.trigger(checked ? 'check' : 'uncheck', row, $this);
          });
      }
      if (this.options.rightFixedColumns) {
          this.$rightfixedBodyColumns.find('> tr[data-index] > td').off('click').on('click', function () {
              var idx = $(this).parents("tr").attr("data-index");
              that.$selectItem.eq(idx).click();
          });
      }

      this.$selectItem.off('click').on('click', function (event) {
          var idx = $(this).parents("tr").attr("data-index");
          if(flag1){
              if(that.$selectItem1) that.$selectItem1.eq(idx).click();
          }
          var bfromtd = $(this).data("fromtd");
          $(this).removeData("fromtd");
          event.stopImmediatePropagation();

          var $this = $(this),
              checked = $this.prop('checked'),
              data_index = $this.data('index'),
              row = that.data[data_index];

          if (that.options.maintainSelected && $(this).is(':radio')) {
              $.each(that.options.data, function (i, row) {
                  row[that.header.stateField] = false;
              });
          }

          row[that.header.stateField] = checked;

          //处理分组选中
          if(row["isGroupRow"] == true && that.options.groupSelect == true ){
              var loop = true;
              var GROUP_INDEX = row["GROUP_INDEX"];
              while (GROUP_INDEX !=undefined && data_index < that.data.length &&  loop ){
                  data_index++;

                  var nextRow = that.data[data_index]
                  if(nextRow == undefined){break; }
                  loop = GROUP_INDEX == nextRow["GROUP_INDEX"];

                  if(loop){
                      nextRow[that.header.stateField] = checked;
                      if(checked == true){
                          that.$selectItem.eq(data_index).prop("checked",true).attr("checked",true);
                      }else{
                          that.$selectItem.eq(data_index).prop("checked",false).removeAttr("checked");
                      }
                  }
              }
          }

          if (that.options.singleSelect || (bfromtd && that.options.clickSingleSelect)) {
              that.$selectItem.not(this).each(function () {
                  that.data[$(this).data('index')][that.header.stateField] = false;
              });
              that.$selectItem.filter(':checked').not(this).prop('checked', false);
          }

          that.updateSelected();
          that.trigger(checked ? 'check' : 'uncheck', row, $this);
      });
     
  };

  BootstrapTable.prototype.resetView = function () {
      _resetView.apply(this, Array.prototype.slice.apply(arguments));

      if (!this.options.leftFixedColumns && !this.options.rightFixedColumns) {
          return;
      }

      clearTimeout(this.timeoutHeaderColumns_);
      this.timeoutHeaderColumns_ = setTimeout($.proxy(this.fitHeaderColumns, this), this.$el.is(':hidden') ? 100 : 0);

      clearTimeout(this.timeoutBodyColumns_);
      this.timeoutBodyColumns_ = setTimeout($.proxy(this.fitBodyColumns, this), this.$el.is(':hidden') ? 100 : 0);
  };

  BootstrapTable.prototype.fitHeaderColumns = function () {
      var that = this,
          visibleFields = this.getVisibleFields(),
          headerWidthL = 0, headerWidthR = 0;
      if (that.options.leftFixedColumns) {
          this.$body.find('tr:first-child:not(.no-records-found) > *').each(function (i) {
              var $this = $(this),
                  index = i;

              if (i >= that.options.leftFixedNumber) {
                  return false;
              }

              if (that.options.detailView && !that.options.cardView) {
                  index = i - 1;
              }

              that.$fixedHeader.find('thead th[data-field="' + visibleFields[index] + '"]')
                  .find('.fht-cell').width($this.innerWidth() - 1);
                  headerWidthL += $this.outerWidth();
          });
          this.$fixedHeader.width(headerWidthL - 1).show();
          this.$selectAll = this.$fixedHeader.find('[name="btSelectAll"]');
          this.$selectAll.off('click').on('click',function(){
              that.checkAll_($(this).prop("checked"))
          })
      }
      if (that.options.rightFixedColumns) {
          var theadTh = this.$body.find('tr:first-child:not(.no-records-found) > *').length;
          this.$body.find('tr:first-child:not(.no-records-found) > *').each(function (i) {
              var $this = $(this),
                  index = i;
              if (i >= theadTh - that.options.rightFixedNumber) {
                  that.$rightfixedHeader.find('thead th[data-field="' + visibleFields[index] + '"]')
                      .find('.fht-cell').width($this.innerWidth());
                      headerWidthR += $this.outerWidth();
              }
          });
          this.$rightfixedHeader.width(headerWidthR - 3).show();
      }
  };

  BootstrapTable.prototype.fitBodyColumns = function () {
      var that = this,
          top = -(parseInt(this.$el.css('margin-top')) - 2),
          height = this.$tableBody.height() - 2;

      if (that.options.leftFixedColumns) {
          if (!this.$body.find('> tr[data-index]').length) {
              this.$fixedBody.hide();
              return;
          }
          if (!this.options.height) {
              top = this.$fixedHeader.height() - 1;
              height = height - top;
          }
          this.$fixedBody.css({
              width: this.$fixedHeader.width(),
              height: height+6,
              top: 1.4
          }).show();

          this.$body.find('> tr').each(function (i) {
              that.$fixedBody.find('tbody tr:eq(' + i + ')').height($(this).height());
          });

          this.$tableBody.on('scroll', function () {
              that.$fixedBody.find('table').css('top', -$(this).scrollTop());
          });
          this.$body.find('> tr[data-index]').off('hover').hover(function () {
              var index = $(this).data('index');
              that.$fixedBody.find('tr[data-index="' + index + '"]').addClass('hover');
          }, function () {
              var index = $(this).data('index');
              that.$fixedBody.find('tr[data-index="' + index + '"]').removeClass('hover');
          });
          this.$fixedBody.find('tr[data-index]').off('hover').hover(function () {
              var index = $(this).data('index');
              that.$body.find('tr[data-index="' + index + '"]').addClass('hover');
          }, function () {
              var index = $(this).data('index');
              that.$body.find('> tr[data-index="' + index + '"]').removeClass('hover');
          });
      }
      if (that.options.rightFixedColumns) {
          if (!this.$body.find('> tr[data-index]').length) {
              this.$rightfixedBody.hide();
              return;
          }
          if (!this.options.height) {
              top = this.$rightfixedHeader.height() - 1;
              height = height - top;
          }
          if(this.$body.height() > this.$body.parent().parent().height() - 18){
              var right = 6;
          }else{
              var right = 0;
          }
          this.$rightfixedBody.css({
              width: this.$rightfixedHeader.width()+2,
              height: height + 5,
              right: right
          }).show();

          this.$rightfixedHeader.css({
              right: right
          }).show();

          this.$body.find('> tr').each(function (i) {
              that.$rightfixedBody.find('tbody tr:eq(' + i + ')').height($(this).height());
          });

          this.$tableBody.on('scroll', function () {
              that.$rightfixedBody.find('table').css('top', -$(this).scrollTop());
          });
          this.$body.find('> tr[data-index]').off('hover').hover(function () {
              var index = $(this).data('index');
              that.$rightfixedBody.find('tr[data-index="' + index + '"]').addClass('hover');
          }, function () {
              var index = $(this).data('index');
              that.$rightfixedBody.find('tr[data-index="' + index + '"]').removeClass('hover');
          });
          this.$rightfixedBody.find('tr[data-index]').off('hover').hover(function () {
              var index = $(this).data('index');
              that.$body.find('tr[data-index="' + index + '"]').addClass('hover');
          }, function () {
              var index = $(this).data('index');
              that.$body.find('> tr[data-index="' + index + '"]').removeClass('hover');
          });
      }
  };
  BootstrapTable.prototype.checkAll = function () {
      this.checkAll_(true);
  };
  BootstrapTable.prototype.uncheckAll = function () {
      this.checkAll_(false)
  };
  BootstrapTable.prototype.getSelections = function () {
      var that = this;
      return $.grep(this.options.data, function (row,index) {
          // fix #2424: from html with checkbox
          row["row_index"]=index;
          return row[that.header.stateField] === true;
      });
  };
  BootstrapTable.prototype.checkAll_ = function (checked) {
      var rows;
      if (!checked) {
          rows = this.getSelections();
      }
      this.$selectAll.add(this.$selectAll_).prop('checked', checked);
      this.$selectItem.filter(':enabled').prop('checked', checked);
      if (this.options.leftFixedColumns) {
          this.$selectItem1.filter(':enabled').prop('checked', checked);
      }
      this.updateRows();
      if (checked) {
          rows = this.getSelections();
      }
      this.trigger(checked ? 'check-all' : 'uncheck-all', rows);
  };
  BootstrapTable.prototype.updateRows = function () {
      var that = this;
      this.$selectItem.each(function () {
          that.data[$(this).data('index')][that.header.stateField] = $(this).prop('checked');
      });
      if (this.options.leftFixedColumns) {
          this.$selectItem1.each(function () {
              that.data[$(this).data('index')][that.header.stateField] = $(this).prop('checked');
          });
      }
      that.updateSelected();
  };
  BootstrapTable.prototype.updateSelected = function () {
      var that = this;
      var checkAll = this.$selectItem.filter(':enabled').length &&
          this.$selectItem.filter(':enabled').length ===
          this.$selectItem.filter(':enabled').filter(':checked').length;
      this.$selectAll.add(this.$selectAll_).prop('checked', checkAll);
      
      if(that.$selectItem1){
          that.$selectItem1.each(function () {
              $(this).closest('tr')[$(this).prop('checked') ? 'addClass' : 'removeClass']('selected');
              flag1 = true;
          });
      }
      this.$selectItem.each(function () {
          var _this = $(this);
          var index = $(this).attr("data-index")
          $(this).closest('tr')[$(this).prop('checked') ? 'addClass' : 'removeClass']('selected');
          if(that.options.rightFixedColumns){
              that.$rightfixedBodyColumns.find('> tr[data-index='+index+']')[_this.prop('checked') ? 'addClass' : 'removeClass']('selected');
          }
      });
  };
})(jQuery);